<template>
  <section class="text-gray-700 body-font overflow-hidden bg-white absolute inset-x-0 top-20">
    <div class="container px-5 mx-auto">
      <div class="mx-auto flex flex-wrap justify-center">
        <img
          v-if="book.imageLinks?.thumbnail"
          :src="book.imageLinks?.thumbnail"
          :alt="book.title"
          class="lg:w-4/12 w-5/12 object-cover object-center rounded border border-gray-200"
        />
        <div class="lg:w-8/12 w-full lg:pl-10 lg:py-6 mt-6 lg:mt-0">
          <h2
            class="text-sm title-font text-gray-500 tracking-widest flex items-center justify-center"
          >
            <div v-for="author in book.authors" v-bind:key="author">{{ author }}&nbsp;&nbsp;</div>
          </h2>
          <h1 class="text-gray-900 text-3xl title-font font-medium mb-1">
            {{ book.title }}
          </h1>

          <h2
            class="text-sm title-font text-gray-500 tracking-widest flex items-center justify-center"
          >
            Date de sortie : {{ book.publishedDate }}
          </h2>
          <div class="flex mb-4">
            <span v-if="book.averageRating" class="flex items-center">
              <svg
                v-for="index2 in book.averageRating"
                :key="index2"
                fill="currentColor"
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                class="w-4 h-4 text-red-500"
                viewBox="0 0 24 24"
              >
                <path
                  d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"
                ></path>
              </svg>
              <div v-if="book.difference">
                <svg
                  v-for="index in book.difference"
                  :key="index"
                  fill="none"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  class="w-4 h-4 text-red-500"
                  viewBox="0 0 24 24"
                >
                  <path
                    d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"
                  ></path>
                </svg>
              </div>
              <span class="text-gray-600 ml-3">{{ book.ratingsCount }} Notes</span>
            </span>

            <span v-else class="flex items-center text-gray-600 ml-3">Aucune note</span>
            <span class="flex ml-3 pl-3 py-2 border-l-2">
              <button
                v-if="!booksIsNote && idUser"
                class="flex ml-auto text-white bg-orange-book border-0 py-2 px-6 focus:outline-none hover:bg-orange-book-hover rounded"
                @click="noteBook()"
              >
                Noter
              </button>
              <button
                v-if="booksIsNote && idUser"
                class="flex ml-auto text-white bg-orange-book border-0 py-2 px-6 focus:outline-none hover:bg-orange-book-hover rounded"
                @click="seeMyNote()"
              >
                Voir ma note
              </button>
            </span>
          </div>
          <p class="leading-relaxed">
            {{ book.description }}
          </p>

          <div class="flex mt-6 items-center pb-5 border-b-2 border-gray-200 mb-5"></div>

          <div class="container mx-auto">
            <div class="grid grid-cols-3 gap-4 mt-6">
              <div>{{ book.pageCount }} pages</div>
              <div>Isbn: {{ isbnBook }}</div>
              <div>{{ book.publisher }}</div>
            </div>
          </div>

          <div class="flex items-center pb-5 border-b-2 border-gray-200 mb-5"></div>

          <div class="flex mb-5">
            <span class="title-font font-medium text-2xl text-gray-900">{{ price }} €</span>

            <button
              v-if="idUser"
              v-on:click="addToWish()"
              :class="
                isWish
                  ? 'flex ml-auto rounded-full w-10 h-10 bg-red-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
                  : 'flex ml-auto rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
              "
            >
              <svg
                xmlns="http://www.w3.org/2000/svg"
                class="h-6 w-6"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
                stroke-width="2"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M5 5a2 2 0 012-2h10a2 2 0 012 2v16l-7-3.5L5 21V5z"
                />
              </svg>
            </button>
            <button
              v-if="idUser"
              v-on:click="addToRead()"
              :class="
                isRead
                  ? 'rounded-full w-10 h-10 bg-red-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
                  : 'rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
              "
            >
              <svg
                class="w-6 h-6"
                fill="none"
                stroke="currentColor"
                viewBox="0 0 24 24"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="M12 6.253v13m0-13C10.832 5.477 9.246 5 7.5 5S4.168 5.477 3 6.253v13C4.168 18.477 5.754 18 7.5 18s3.332.477 4.5 1.253m0-13C13.168 5.477 14.754 5 16.5 5c1.747 0 3.332.477 4.5 1.253v13C19.832 18.477 18.247 18 16.5 18c-1.746 0-3.332.477-4.5 1.253"
                ></path>
              </svg>
            </button>
            <button
              v-if="idUser"
              v-on:click="addToFav()"
              :class="
                isFav
                  ? 'rounded-full w-10 h-10 bg-red-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
                  : 'rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
              "
            >
              <svg
                class="w-6 h-6"
                fill="none"
                stroke="currentColor"
                viewBox="0 0 24 24"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="M4.318 6.318a4.5 4.5 0 000 6.364L12 20.364l7.682-7.682a4.5 4.5 0 00-6.364-6.364L12 7.636l-1.318-1.318a4.5 4.5 0 00-6.364 0z"
                ></path>
              </svg>
            </button>

            <button
              v-on:click="shareContent()"
              :class="
                idUser
                  ? 'rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4 rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
                  : 'flex ml-auto rounded-full w-10 h-10 bg-gray-200 p-0 border-0 inline-flex items-center justify-center text-gray-500 ml-4'
              "
            >
              <svg
                xmlns="http://www.w3.org/2000/svg"
                class="h-6 w-6"
                fill="none"
                viewBox="0 0 24 24"
                stroke="currentColor"
                stroke-width="2"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M8.684 13.342C8.886 12.938 9 12.482 9 12c0-.482-.114-.938-.316-1.342m0 2.684a3 3 0 110-2.684m0 2.684l6.632 3.316m-6.632-6l6.632-3.316m0 0a3 3 0 105.367-2.684 3 3 0 00-5.367 2.684zm0 9.316a3 3 0 105.368 2.684 3 3 0 00-5.368-2.684z"
                />
              </svg>
            </button>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { serchABookByIsbn } from "./../services/bookService";
import { getUidCurrentUser } from "./../services/authenticationService";
import {
  getUserBookByIdUserAndIdBook,
  isKnowBook,
  addUserBook,
  updataData,
  isStatUser,
  createUserStat,
  updateStatUser,
} from "./../services/firestoreService";

import { Share } from "@capacitor/share";

export default {
  name: "DetailsBook",

  data() {
    return {
      book: {},
      price: null,
      isFav: false,
      idUser: null,
      isRead: false,
      isWish: false,
      booksIsNote: false,
    };
  },

  props: {
    isbnBook: String,
  },
  watch: {
    idBook: async function displayBook() {
      const bookItem = await serchABookByIsbn(this.isbnBook);
      this.price = bookItem.items[0].saleInfo.listPrice.amount;
      this.book = bookItem.items[0].volumeInfo;
      this.book.averageRating = Math.ceil(this.book.averageRating);
      this.book.publishedDate = this.formatDate(this.book.publishedDate);
      this.getDifferenceRate();
    },
  },

  methods: {
    getDifferenceRate() {
      if (this.book.averageRating < 5) {
        this.book.difference = 5 - this.book.averageRating;
      }
    },

    formatDate(date) {
      const dateToReturn = new Date(date);
      const dd = String(dateToReturn.getDate()).padStart(2, "0");
      const mm = String(dateToReturn.getMonth() + 1).padStart(2, "0"); //January is 0!
      const yyyy = dateToReturn.getFullYear();

      return dd + "/" + mm + "/" + yyyy;
    },

    async getDataUserBook() {
      let userBook = await getUserBookByIdUserAndIdBook(this.idUser, this.isbnBook, "userBook");

      userBook = userBook.data();

      this.isFav = userBook.favoris;
      this.isWish = userBook.wish;
      this.isRead = userBook.read;
    },

    async addToFav() {
      this.createStatUser();

      if (await isKnowBook(this.idUser, this.isbnBook)) {
        const relation = await getUserBookByIdUserAndIdBook(this.idUser, this.isbnBook, "userBook");
        this.isFav = await updataData(relation, "userBook", "favoris");
      } else {
        await addUserBook(this.idUser, this.isbnBook, true, false, false);
        this.isFav = true;
      }
      updateStatUser(this.idUser, "favoris", this.isFav);
    },

    async addToWish() {
      this.createStatUser();

      if (await isKnowBook(this.idUser, this.isbnBook)) {
        const relation = await getUserBookByIdUserAndIdBook(this.idUser, this.isbnBook, "userBook");
        this.isWish = await updataData(relation, "userBook", "wish");
      } else {
        await addUserBook(this.idUser, this.isbnBook, false, true, false);
        this.isWish = true;
      }
      updateStatUser(this.idUser, "wish", this.isWish);
    },

    async addToRead() {
      this.createStatUser();

      if (await isKnowBook(this.idUser, this.isbnBook)) {
        const relation = await getUserBookByIdUserAndIdBook(this.idUser, this.isbnBook, "userBook");
        this.isRead = await updataData(relation, "userBook", "read");
      } else {
        await addUserBook(this.idUser, this.isbnBook, false, false, true);
        this.isRead = true;
      }

      updateStatUser(this.idUser, "read", this.isRead);
    },

    async shareContent() {
      await Share.share({
        title: this.book.title,
        text: "Je voulais te partager ma découverte : " + this.book.title,
        url: "https://bookedex-1eab1.web.app/book-details/" + this.isbnBook,
        dialogTitle: "Partage de " + this.book.title,
      });
    },

    async createStatUser() {
      if (!(await isStatUser(this.idUser))) {
        createUserStat(this.idUser);
      }
    },

    noteBook() {
      this.$router.push({
        name: "NotePage",
        params: { id: this.isbnBook },
      });
    },

    seeMyNote() {
      this.$router.push({
        name: "MyNotePage",
        params: { id: this.isbnBook },
      });
    },
  },

  async created() {
    this.idUser = await getUidCurrentUser();

    this.getDataUserBook();

    const bookItem = await serchABookByIsbn(this.isbnBook);
    this.price = bookItem.items[0].saleInfo.listPrice?.amount;
    this.book = bookItem.items[0].volumeInfo;
    this.book.averageRating = Math.ceil(this.book.averageRating);
    this.book.publishedDate = this.formatDate(this.book.publishedDate);
    this.getDifferenceRate();

    if (await isKnowBook(this.idUser, this.isbnBook)) {
      const relation = await getUserBookByIdUserAndIdBook(this.idUser, this.isbnBook, "userBook");
      if (relation.data().note) {
        this.booksIsNote = true;
      }
    }
  },
};
</script>
